/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/SARTConfig.h $
 $LastChangedRevision: 95 $
 $Date: 2014-07-02 19:43:36 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 This class is responsible for the configuration of the
 Simultaneous Reconstruction Algorithm Technique (SART)
 */

#ifndef SARTCONFIG_H_
#define SARTCONFIG_H_

#include "blkdta.h"

class SARTConfig
{

private:
	SARTConfig();
	virtual ~SARTConfig();

public:
	static REAL relaxiation; // the relaxation parameter. default value = 1
	static REAL zeroThreshold; // the threshold when a value is set to zero. default value = 0.00001

	/**
	 * Reads all parameters of the SART configuration from the snark input file
	 */
	static BOOLEAN readSARTConfiguration();

private:
	static void printErrorMessage(char* errorString);
};

#endif /* SARTCONFIG_H_ */
