/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/anglst.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 anglst.cpp,v 1.3 2008/09/25 13:17:44 jklukowska Exp
 */

#include <cstdio>
#include <cmath>

#include "blkdta.h"
#include "consts.h"

#include "anglst.h"

anglst_class Anglst;

anglst_class::~anglst_class()
{
	if (pbase != NULL)
		delete[] pbase;
	if (bth != NULL)
		delete[] bth;
	if (bsin != NULL)
		delete[] bsin;
	if (bcos != NULL)
		delete[] bcos;
}

void anglst_class::Init(INTEGER prjnum)
{
	bth = new REAL[prjnum];
	bsin = new REAL[prjnum];
	bcos = new REAL[prjnum];
}

void anglst_class::InitDiv(REAL* pang, INTEGER prjnum)
{
	REAL theta;
	REAL dtor;
	int np;

	dtor = Consts.pi / (REAL) 180.0;

	for (np = 0; np < prjnum; np++)
	{
		theta = pang[np] * dtor;
		bth[np] = theta;
		bsin[np] = (REAL) sin(theta);
		bcos[np] = (REAL) cos(theta);
#ifdef FFCOMPARE
#endif
	}
}

/*
 C.... ESTABLISH SIN AND COSINE TABLES NEEDED FOR DIVERGENT GEOMETRY
 C.... FOR USE BY POSIT.
 C.... CALLED BY RDPROJ,  EXALG,  AND EVAL.
 */

void anglst_class::genphi()
{
	INTEGER nmax;
	REAL th;

	nmax = (GeoPar.nrays - 1) / 2;
	sphi = new REAL[nmax];
	cphi = new REAL[nmax];

	for (int nr = 0; nr < nmax; nr++)
	{
		if (GeoPar.arc)
			th = GeoPar.pinc / GeoPar.stod * (nr + 1);
		if (GeoPar.tang)
			th = (REAL) atan2((nr + 1) * GeoPar.pinc, GeoPar.stod);

		sphi[nr] = (REAL) sin(th);
		cphi[nr] = (REAL) cos(th);
	}
}

