/* 
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/emap.h $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************
 */

#ifndef EMAP_H
#define EMAP_H

#include <cstdio>
#include "alg.h"

class MAPEM_class
{
public:
	REAL* qj;REAL* Kx;REAL* Sx;REAL* Wjj;REAL* prj;INTEGER idxmax, idymax, idx,
			idy;REAL* Sjjinv;REAL gamma1, sclfactor, delta;BOOLEAN mapevl;
};

class emap_class: public alg_class
{
private:
	MAPEM_class MAPEM;
	FILE* MAPUser1;

	void EvalMAP(REAL* recon, INTEGER iter);
	void InitMAP(REAL* recon);
	void ReadInp(INTEGER area, INTEGER nelem, INTEGER usrays, INTEGER prjnum, BOOLEAN *flag);BOOLEAN MAP(REAL* recon);
	void applyK(REAL* source, REAL* dest, INTEGER nelem);BOOLEAN findqpart( INTEGER np, INTEGER nr, REAL yi, REAL* recon, REAL* qtilde);
	void sscal(INTEGER size, REAL factor, REAL* dest, INTEGER spac);

public:
	INTEGER Init();BOOLEAN Run(REAL* recon, INTEGER* list, REAL* weight, INTEGER iter);INTEGER Reset();
};

#endif      
