/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/errpar.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 THIS ROUTINE CHECKS AND PREPARES THE CONSTANTS USED BY THE ERROR
 ROUTINE ERRFAC
 */

#include <cstdio>
#include <cmath>
#include "blkdta.h"
#include "geom.h"
#include "spctrm.h"
#include "noise.h"
#include "err.h"
#include "errpar.h"

void errpar(BOOLEAN alg)
{
	int i;

	Err.errtyp = 0;

	if (!(NoisePar.quanin == 0))
	{

		// QUANTUM NOISE

		Err.bf = 0.0;
		for (i = 0; i < Spctrm.nergy; i++)
		{
			Err.bf += Spctrm.engwt[i] * (REAL) exp(-Spctrm.backgr[i]);
		}

		Err.bf = (REAL) 1.0 / (Err.bf * NoisePar.quanmn);
		Err.af = Err.bf * ((REAL) 2.0 / NoisePar.quancm + (REAL) 1.0);

		Err.errtyp = 4;
		if (GeoPar.strip)
			Err.errtyp = 8;
	}
	// MULTIPLICATIVE NOISE
	if (NoisePar.ultnfl)
	{

		Err.mfactr = (NoisePar.ultnsd / NoisePar.ultnmn)
				* (NoisePar.ultnsd / NoisePar.ultnmn);

		Err.errtyp += 2;
	}

	// ADDITIVE NOISE

	if (NoisePar.addnfl)
	{
		Err.afactr = NoisePar.addnsd * NoisePar.addnsd;

		Err.errtyp++;
	}
	return;
}
