/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/foru_ftmap.cpp $
 $LastChangedRevision: 85 $
 $Date: 2014-07-02 16:07:08 -0400 (Wed, 02 Jul 2014) $
 $Author: agulati $
 ***********************************************************

 PURPOSE: REARRANGE THE PROJECTION DATA (IN VFROM) IN A FORM
 SUITABLE FOR FAST FOURIER ROUTINES (I.E. CHANGE THE
 PHASE SO THAT THE ORIGIN IS THE 1ST ELEMENT IN ARRAY )
 AND PUT INTO THE ARRAY VTO
 */
// bug79 - problem with fourier algorithm
#include <cstdio>

#include "blkdta.h"
#include "fourie.h"

#include "foru.h"

void foru_class::ftmap(REAL* vfrom, REAL* vto, BOOLEAN revers)
{
	int i;
	INTEGER kh;
	INTEGER kl;

	Fourie.midr = Fourie.nsize1 / 2 - 1;

	// IF REVERS IS TRUE ,REVERSE THE  PROJECTION DATA (SEE ALSO PRJTRN)

	if (revers)
	{

		kh = Fourie.midr + 1;

		for (i = 0; i <= kh; i++)
		{     // bug79 - swr 2/11/05
			vto[i] = vfrom[Fourie.midr + i];
		}

		kl = Fourie.midr + 2;

		for (i = kl; i < Fourie.nsize1; i++)
		{
			vto[i] = vfrom[i - Fourie.midr - 2];     // bug79 - swr 2/11/05
		}
	}
	else
	{
		for (i = 0; i <= Fourie.midr; i++)
		{
			vto[i] = vfrom[Fourie.midr - i];
		}

		kl = Fourie.midr + 1;

		for (i = kl; i < Fourie.nsize1; i++)
		{
			vto[i] = vfrom[Fourie.nsize1 + Fourie.midr - i];
		}
	}
}
