/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/getfom.c $
 $LastChangedRevision: 137 $
 $Date: 2014-07-15 16:38:33 -0400 (Tue, 15 Jul 2014) $
 $Author: bprommegger $
 ***********************************************************

 Previously part of SuperSNARK
 */

#include <string.h>
#include "experimenter.h"
#include "getfom.h"

/* ----------------------- getfom.c -----------------------------------
 This function examines the input string and returns several flags
 whose values depend on the figures of merit present in the string

 INPUTS:
 string - input string.

 OUTPUTS:
 stru - equals 1 if STRU is present, else equals 0
 poin - equals 1 if POIN is present, else equals 0
 hitr - equals 1 if HITR is present, else equals 0
 usr1 _ equals 1 if USR1 is present, else equals 0
 usr... _ equals 1 if USR... is present, else equals 0
 iroi _ equals 1 if IROI is present, else equals 0
 klds _ equals 1 if KLDS is present, else equals 0
 wsqd _ equals 1 if WSQD is present, else equals 0
 */

void getfom(char* string, int* stru, int* poin, int* hitr, int* usr1, int* usr2, int* usr3, int* usr4, int* usr5, int* iroi, int* klds, int* wsqd)
{
	*stru = 0;
	*poin = 0;
	*hitr = 0;
	*usr1 = 0;
	*usr2 = 0;
	*usr3 = 0;
	*usr4 = 0;
	*usr5 = 0;
	*iroi = 0;
	*klds = 0;
	*wsqd = 0;

	if (strcasestr(string, "STRU") != NULL)
	{
		*stru = 1;
	}

	if ((strcasestr(string, "POIN") != NULL))
	{
		*poin = 1;
	}

	if ((strcasestr(string, "HITR") != NULL))
	{
		*hitr = 1;
	}

	if ((strcasestr(string, "USR1") != NULL))
	{
		*usr1 = 1;
	}

	if ((strcasestr(string, "USR2") != NULL))
	{
		*usr2 = 1;
	}

	if ((strcasestr(string, "USR3") != NULL))
	{
		*usr3 = 1;
	}

	if ((strcasestr(string, "USR4") != NULL))
	{
		*usr4 = 1;
	}

	if ((strcasestr(string, "USR5") != NULL))
	{
		*usr5 = 1;
	}
	if ((strcasestr(string, "IROI") != NULL))
	{
		*iroi = 1;
	}
	if ((strcasestr(string, "KLDS") != NULL))
	{
		*klds = 1;
	}
	if ((strcasestr(string, "WSQD") != NULL))
	{
		*wsqd = 1;
	}
}
