/*
 ***********************************************************
 $SNARK_Header: S N A R K  1 4 - A PICTURE RECONSTRUCTION PROGRAM $
 $HeadURL: svn://dig.cs.gc.cuny.edu/snark/trunk/src/snark/sec_cri2.cpp $
 $LastChangedRevision: 107 $
 $Date: 2014-07-07 12:06:15 -0400 (Mon, 07 Jul 2014) $
 $Author: olangthaler $
 ***********************************************************
 */

#include "sec_cri2.h"
#include "math.h"
#include "anglst.h"
#include "blob.h"

using namespace std;

REAL sec_cri2_class::Run(REAL* image)
{
	INTEGER dimensions = GeoPar.nelem;
	// pixels over which to iterate (skip last line and new bottom right pixel)
	INTEGER pixelcount = GeoPar.area - dimensions - 2;

	REAL psi = 0;
	for (INTEGER i = dimensions + 2; i < pixelcount; i++)
	{
		// skip right-most column
		if (i % (dimensions) == 0) continue;
		// skip left column
		if (i % (dimensions) == 1) continue;

		psi += pow(image[i - 1] - ((image[i - 1 - dimensions - 1] + image[i - 1 - dimensions] + image[i - dimensions] + image[i - 2] + image[i] + image[i - 1 + dimensions - 1] + image[i - 1 + dimensions] + image[i + dimensions]) / 8), 2);
	}

	return psi;
}
