/** @file line_real_set_t.cpp
    @package snark14Display
    @author Bruno M. Carvalho and Deniz Sarioz
    @description implementation of functions in line_real_set_t class
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#include <iostream>

#include "verbosity.hpp"
#include "line_real_set_t.hpp"
#include "line_real_t.hpp"

line_real_set_t::line_real_set_t(int minXin, int maxXin, double minYin, double maxYin) {
  minX = minXin;
  maxX = maxXin;
  minY = minYin;
  maxY = maxYin;
}

void line_real_set_t::add(line_real_t& line_real) {
  line_real.setset(this);
  data.push_back(line_real);
  if(std::verbose > 2) {
    //  line_real.show();
    //  std::cerr << " $$Added a line_real_t to line_real_set_t " << this << " $$ ";
  }
} // line_real_set_t::add()

bool line_real_set_t::empty()  {    return data.empty();  }
void line_real_set_t::clear()  {    data.clear();  }
int line_real_set_t::getMinX()    {    return minX;  }
int line_real_set_t::getMaxX()    {    return maxX;  }
double line_real_set_t::getMinY() {    return minY;  }
double line_real_set_t::getMaxY() {    return maxY;  }
