/** @file SnarkInput.h
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef SNARKINPUT_H
#define SNARKINPUT_H

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <qapplication.h>
#include <qwidget.h>
#include <qmainwindow.h>
#include <qmultilineedit.h>
#include <qmenubar.h>
#include <qpopupmenu.h>
#include <qtoolbar.h>
#include <qpushbutton.h>
#include <qtoolbutton.h>
#include <qiconset.h>
#include <qpixmap.h>
#include <qlayout.h>
#include <qlabel.h>
#include <qtooltip.h>
#include <qmessagebox.h>
#include <qfiledialog.h>
#include <qstringlist.h>
#include <qbuttongroup.h>
#include <qradiobutton.h>

class SnarkInput : public QMainWindow {

  Q_OBJECT; 

public:
  SnarkInput(QWidget *parent=0, const char *name=0, WFlags f=0);
  FILE *inputfile;
  QString inputfilename;
  QString outputfilename;
  QPopupMenu* filemenu;
  QPopupMenu* commandsmenu;
  QPopupMenu* runsnarkmenu;
  QPopupMenu* helpmenu;
  QMultiLineEdit* currentinput;
  QButtonGroup* insertbuttongroup;
  QRadioButton* int1button;
  QRadioButton* int2button;
private slots:
  void setInsertType(int);
  void openFile();
  void newInputFile();
  void saveFile();
  void saveFileAs();
  void runSnark();
  //  void help();
  //  void SNARKManual();
  void about();
  void callComment(); 
  void callTrace();  
  void callMode(); 
  void callCreate();  
  void callPicture(); 
  void callProjection();  
  void callSelect(); 
  void callBasis(); 
  void callStop();
  void callSuper();
  void callExecute(); 
  void callEvaluate();  
  void callDisplay(); 
  void callPunch();  
  void callLines(); 
  void callSkunk(); 
  void addEnd(); 
};
#endif  // SNARKINPUT_H
