/** @file evaluate.h
    @package snark14Input
    @author Bruno M. Carvalho and Deniz Sarioz
    licensed under (open-source) QPL v1.0
    which accompanies this distribution in the file QPL
*/

#ifndef EVALUATEWINDOW_H
#define EVALUATEWINDOW_H

#include <qvariant.h>
#include <qdialog.h>
class QVBoxLayout; 
class QHBoxLayout; 
class QGridLayout; 
class QButtonGroup;
class QFrame;
class QLabel;
class QLineEdit;
class QMultiLineEdit;
class QPushButton;
class QRadioButton;

class evaluatewindow : public QDialog
{ 
    Q_OBJECT

public:
    evaluatewindow( QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0 );
    ~evaluatewindow();
    QString getOutput();
    QLabel* evaluatelabel;
    QButtonGroup* evaluatebuttongroup;
    QRadioButton* resolutionbutton;
    QRadioButton* pointbutton;
    QRadioButton* bothbutton;
    QRadioButton* nonebutton;
    QRadioButton* linebutton;
    QButtonGroup* evaluatebuttongroup2;
    QRadioButton* wholepicbutton;
    QLineEdit* evalnamefield;
    QLabel* evalnamelabel;
    QLineEdit* lowden;
    QLabel* lowdenlabel;
    QLineEdit* highden;
    QLabel* highdenlabel;
    QRadioButton* selectivebutton;
    QMultiLineEdit* shapes;
    QLabel* shapeslabel;
    QLabel* shapesinstructionslabel;
    QLineEdit* iterationflagline;
    QLabel* iterationflaglabel;
    QFrame* Line4;
    QPushButton* okbutton;
    QPushButton* cancelbutton;
private slots:
      //void activateFields();
    void activateWholepicFields();
    void activateSelectiveFields();
    void checkValues();
};

#endif // EVALUATEWINDOW_H
